curl --request POST \
--url https://notifications.{region}.basaltic.sh/v1/topics/{topic_id}/publish-batch \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"entries": [
{
"id": "entry-1",
"message": "osd.22 reports a firmware impending failure",
"subject": "Disk pressure on europa",
"message_structure": "json",
"attributes": {
"severity": {
"type": "String",
"value": "critical"
},
"latency": {
"type": "Number",
"value": "250"
}
}
}
]
}
'import requests
url = "https://notifications.{region}.basaltic.sh/v1/topics/{topic_id}/publish-batch"
payload = { "entries": [
{
"id": "entry-1",
"message": "osd.22 reports a firmware impending failure",
"subject": "Disk pressure on europa",
"message_structure": "json",
"attributes": {
"severity": {
"type": "String",
"value": "critical"
},
"latency": {
"type": "Number",
"value": "250"
}
}
}
] }
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
entries: [
{
id: 'entry-1',
message: 'osd.22 reports a firmware impending failure',
subject: 'Disk pressure on europa',
message_structure: 'json',
attributes: {
severity: {type: 'String', value: 'critical'},
latency: {type: 'Number', value: '250'}
}
}
]
})
};
fetch('https://notifications.{region}.basaltic.sh/v1/topics/{topic_id}/publish-batch', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://notifications.{region}.basaltic.sh/v1/topics/{topic_id}/publish-batch",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'entries' => [
[
'id' => 'entry-1',
'message' => 'osd.22 reports a firmware impending failure',
'subject' => 'Disk pressure on europa',
'message_structure' => 'json',
'attributes' => [
'severity' => [
'type' => 'String',
'value' => 'critical'
],
'latency' => [
'type' => 'Number',
'value' => '250'
]
]
]
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://notifications.{region}.basaltic.sh/v1/topics/{topic_id}/publish-batch"
payload := strings.NewReader("{\n \"entries\": [\n {\n \"id\": \"entry-1\",\n \"message\": \"osd.22 reports a firmware impending failure\",\n \"subject\": \"Disk pressure on europa\",\n \"message_structure\": \"json\",\n \"attributes\": {\n \"severity\": {\n \"type\": \"String\",\n \"value\": \"critical\"\n },\n \"latency\": {\n \"type\": \"Number\",\n \"value\": \"250\"\n }\n }\n }\n ]\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://notifications.{region}.basaltic.sh/v1/topics/{topic_id}/publish-batch")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"entries\": [\n {\n \"id\": \"entry-1\",\n \"message\": \"osd.22 reports a firmware impending failure\",\n \"subject\": \"Disk pressure on europa\",\n \"message_structure\": \"json\",\n \"attributes\": {\n \"severity\": {\n \"type\": \"String\",\n \"value\": \"critical\"\n },\n \"latency\": {\n \"type\": \"Number\",\n \"value\": \"250\"\n }\n }\n }\n ]\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://notifications.{region}.basaltic.sh/v1/topics/{topic_id}/publish-batch")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"entries\": [\n {\n \"id\": \"entry-1\",\n \"message\": \"osd.22 reports a firmware impending failure\",\n \"subject\": \"Disk pressure on europa\",\n \"message_structure\": \"json\",\n \"attributes\": {\n \"severity\": {\n \"type\": \"String\",\n \"value\": \"critical\"\n },\n \"latency\": {\n \"type\": \"Number\",\n \"value\": \"250\"\n }\n }\n }\n ]\n}"
response = http.request(request)
puts response.read_body{
"successful": [
{
"id": "entry-1",
"message_id": "019400aa-bbbb-7ccc-8ddd-eeeeffff0000"
}
],
"failed": [
{
"id": "entry-2",
"code": "NOTIFICATION_MESSAGE_TOO_LARGE",
"message": "Notification exceeds the maximum size (262144 bytes)"
}
]
}{
"error": {
"code": "INVALID_INPUT",
"message": "Invalid request parameters",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}{
"error": {
"code": "UNAUTHORIZED",
"message": "Authentication required",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}{
"error": {
"code": "ACCESS_DENIED",
"message": "You don't have permission to perform this action",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}{
"error": {
"code": "NOT_FOUND",
"message": "Resource not found",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}{
"error": {
"code": "CONFLICT",
"message": "Resource with this name already exists",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}{
"error": {
"code": "IDEMPOTENCY_KEY_REUSED",
"message": "This Idempotency-Key was already used with a different request payload",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}Publicar até 10 notificações
Não atômico. Cada entrada é validada e enfileirada separadamente, com resultado por ID. Um 202 não significa aceitação de todas as entradas; verifique failed.
curl --request POST \
--url https://notifications.{region}.basaltic.sh/v1/topics/{topic_id}/publish-batch \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"entries": [
{
"id": "entry-1",
"message": "osd.22 reports a firmware impending failure",
"subject": "Disk pressure on europa",
"message_structure": "json",
"attributes": {
"severity": {
"type": "String",
"value": "critical"
},
"latency": {
"type": "Number",
"value": "250"
}
}
}
]
}
'import requests
url = "https://notifications.{region}.basaltic.sh/v1/topics/{topic_id}/publish-batch"
payload = { "entries": [
{
"id": "entry-1",
"message": "osd.22 reports a firmware impending failure",
"subject": "Disk pressure on europa",
"message_structure": "json",
"attributes": {
"severity": {
"type": "String",
"value": "critical"
},
"latency": {
"type": "Number",
"value": "250"
}
}
}
] }
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
entries: [
{
id: 'entry-1',
message: 'osd.22 reports a firmware impending failure',
subject: 'Disk pressure on europa',
message_structure: 'json',
attributes: {
severity: {type: 'String', value: 'critical'},
latency: {type: 'Number', value: '250'}
}
}
]
})
};
fetch('https://notifications.{region}.basaltic.sh/v1/topics/{topic_id}/publish-batch', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://notifications.{region}.basaltic.sh/v1/topics/{topic_id}/publish-batch",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'entries' => [
[
'id' => 'entry-1',
'message' => 'osd.22 reports a firmware impending failure',
'subject' => 'Disk pressure on europa',
'message_structure' => 'json',
'attributes' => [
'severity' => [
'type' => 'String',
'value' => 'critical'
],
'latency' => [
'type' => 'Number',
'value' => '250'
]
]
]
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://notifications.{region}.basaltic.sh/v1/topics/{topic_id}/publish-batch"
payload := strings.NewReader("{\n \"entries\": [\n {\n \"id\": \"entry-1\",\n \"message\": \"osd.22 reports a firmware impending failure\",\n \"subject\": \"Disk pressure on europa\",\n \"message_structure\": \"json\",\n \"attributes\": {\n \"severity\": {\n \"type\": \"String\",\n \"value\": \"critical\"\n },\n \"latency\": {\n \"type\": \"Number\",\n \"value\": \"250\"\n }\n }\n }\n ]\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://notifications.{region}.basaltic.sh/v1/topics/{topic_id}/publish-batch")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"entries\": [\n {\n \"id\": \"entry-1\",\n \"message\": \"osd.22 reports a firmware impending failure\",\n \"subject\": \"Disk pressure on europa\",\n \"message_structure\": \"json\",\n \"attributes\": {\n \"severity\": {\n \"type\": \"String\",\n \"value\": \"critical\"\n },\n \"latency\": {\n \"type\": \"Number\",\n \"value\": \"250\"\n }\n }\n }\n ]\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://notifications.{region}.basaltic.sh/v1/topics/{topic_id}/publish-batch")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"entries\": [\n {\n \"id\": \"entry-1\",\n \"message\": \"osd.22 reports a firmware impending failure\",\n \"subject\": \"Disk pressure on europa\",\n \"message_structure\": \"json\",\n \"attributes\": {\n \"severity\": {\n \"type\": \"String\",\n \"value\": \"critical\"\n },\n \"latency\": {\n \"type\": \"Number\",\n \"value\": \"250\"\n }\n }\n }\n ]\n}"
response = http.request(request)
puts response.read_body{
"successful": [
{
"id": "entry-1",
"message_id": "019400aa-bbbb-7ccc-8ddd-eeeeffff0000"
}
],
"failed": [
{
"id": "entry-2",
"code": "NOTIFICATION_MESSAGE_TOO_LARGE",
"message": "Notification exceeds the maximum size (262144 bytes)"
}
]
}{
"error": {
"code": "INVALID_INPUT",
"message": "Invalid request parameters",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}{
"error": {
"code": "UNAUTHORIZED",
"message": "Authentication required",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}{
"error": {
"code": "ACCESS_DENIED",
"message": "You don't have permission to perform this action",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}{
"error": {
"code": "NOT_FOUND",
"message": "Resource not found",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}{
"error": {
"code": "CONFLICT",
"message": "Resource with this name already exists",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}{
"error": {
"code": "IDEMPOTENCY_KEY_REUSED",
"message": "This Idempotency-Key was already used with a different request payload",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}notifications:Publish. Veja NOTIFICATIONS permissões para a lista completa, o escopo de cada ação e um exemplo de política.Autorizações
Um token bearer OAuth 2.0, enviado como Authorization: Bearer <token>. Esta é a forma recomendada de autenticação.
Obtenha o token trocando o par de chaves de acesso de uma conta de serviço em POST /v1/oauth/token com grant_type=client_credentials. Esse é o fluxo padrão de credenciais de cliente; bibliotecas compatíveis com OAuth podem obter e renovar o token para você.
curl -s -u "$KEY_ID:$SECRET" -d grant_type=client_credentials \
https://iam.basaltic.sh/v1/oauth/token
Os tokens duram uma hora por padrão. O mesmo par de chaves de acesso também serve como credencial AWS SigV4 para o endpoint de objetos compatível com S3, que aceita somente esse método de autenticação.
Cabeçalhos
Chave opcional gerada pelo cliente que torna uma criação segura para reprodução. A reintentar uma solicitação com a mesma chave retorna o resultado original literalmente em vez de criar um recurso duplicado. A reutilização de uma chave com um corpo de solicitação diferente é rejeitada (422); uma solicitação cuja chave ainda está sendo processada retorna 409. Os registros são honrados por 24 horas. Use um UUID ou token exclusivo semelhante.
255Parâmetros de caminho
"a1b2c3d4-5e6f-4a7b-8c9d-0e1f2a3b4c5d"
Corpo
1 - 10 elementsShow child attributes
Show child attributes

